// Datei UebMethoden1.java
/* ------------------------------------------------------------------------
In dieses Programm UebMethoden1 kann man Loesungen zur
Uebung Methoden 1
eintragen und testen. Ersetzen Sie dazu in den Methoden summe, gibAus, ...,
alleRechtwinkligen die gekennzeichneten Zeilen durch "richtige Befehle".
------------------------------------------------------------------------ */
import        de.tfh_berlin.fb6.MethodTest;
import static de.tfh_berlin.fb6.MethodTest.p;
import static de.tfh_berlin.fb6.MethodTest.pln;

public class UebMethoden1 {
   // ---------------------------------------------------------------------
   static public int summe(int n1, int n2) {
      // Liefert die Summe von n1 und n2

      return 999; // SOLL ERSETZT WERDEN
   } // summe
   // ---------------------------------------------------------------------
   static public void gibAus(int a, int b, int c) {
      // Gibt die Namen der Parameter (jeden auf einer neuen Zeile) gefolgt
      // von einem Doppelpunkt ":"  und dem Wert des Parameters aus
      // (mit dem Befehl pln) z.B. so:
      //
      // a: 17
      // b: -22
      // c: 5

      pln("Noch nicht fertig!");  // SOLL ERSETZT WERDEN
   } // gibAus
   // ---------------------------------------------------------------------
   static public int hochZwei(int grundzahl) {
      // Liefert den Wert grundzahl hoch 2.

      return 999; // SOLL ERSETZT WERDEN
   } // hochZwei
   // ---------------------------------------------------------------------
   static public int zweiHoch(int exponent) {
      // Liefert den Wert 2 hoch exponent.
      // Falls der exponent kleiner oder gleich 0 ist, wird 1 als
      // Ergebnis geliefert.

      return 999; // SOLL ERSETZT WERDEN
   } // zweiHoch
   // ---------------------------------------------------------------------
   static public int hoch(int grundzahl, int exponent) {
      // Liefert den Wert grundzahl hoch exponent.
      // Falls der exponent kleiner oder gleich 0 ist, wird 1 als
      // Ergebnis geliefert.

      return 999; // SOLL ERSETZT WERDEN
   } // hoch
   // ---------------------------------------------------------------------
   static public boolean istPrim(final int n) {
      // Liefert true, falls n prim ist, und sonst false.
      // Prueft nur Zahlen bis zur Quadratwurzel aus n als Teiler.
      // Behandelt alle geraden Zahlen "vorweg" als Sonderflle.
      // Der Parameter n wurde als final ("konstant") vereinbart,
      // damit der Ausfuehrer unten in der for-Schleife
      // Math.sqrt(n) nur einmal berechnen muss.

      return false; // SOLL ERSETZT WERDEN
   } // istPrim
   // ---------------------------------------------------------------------
   static public int primDoublette(int minimum) {
      // Liefert die kleinste Primzahl p fuer die gilt:
      // p   ist groesser oder gleich minimum
      // p+2 ist kleiner  oder gleich Integer.MAX_VALUE
      // p+2 ist auch eine Primzahl
      // Gibt es keine solche Primzahl p, wird 0 als Ergebnis geliefert.

      return 999; // SOLL ERSETZT WERDEN
   } // primDoublette
   // ---------------------------------------------------------------------
   static public void alleRechtwinkligen() {
      // Gibt alle Ganzzahltripel (a, b, c) aus fuer die gilt:
      // 1. a, b und c liegen zwischen 1 und MAX (einschliesslich)
      // 2. a ist groesser/gleich b und b ist groesser/gleich c
      // 3. a*a ist gleich b*b + c*c (Pythagoras)
      // Die Ausgabe *eines* solchen Ganzzahltripels sieht etwa so aus:
      // Nr. 19: 50, 40, 30
      // und endet mit einem Blank ' ' und einem Zeilenwechsel '\n'.

      final int MAX = 100;
      int       nr  = 0;

      pln("Noch nicht fertig!"); // SOLL ERSETZT WERDEN
   } // alleRechtwinkligen
   // *********************************************************************
   static final boolean FAILURES_ONLY = true;
   // ---------------------------------------------------------------------
   static public void tst_summe() {
      Object[][] aa = {
         {UebMethoden1.class, "summe"},
         { 2,  1,  1},
         {-2, -1, -1},
         {99, 99,  0},
         {99,  0, 99},
         { 0,  0,  0},
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_summe
   // ---------------------------------------------------------------------
   static public void tst_gibAus() {
      Object[][] aa = {
         {UebMethoden1.class, "gibAus"},
         {"a: 1\nb: 2\nc: 3\n",         1,   2,   3},
         {"a: -3\nb: -2\nc: -1\n",     -3,  -2,  -1},
         {"a: 0\nb: 0\nc: 0\n",         0,   0,   0},
         {"a: 123\nb: 234\nc: 345\n", 123, 234, 345},
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_gibAus
   // ---------------------------------------------------------------------
   static public void tst_hochZwei() {
      Object[][] aa = {
         {UebMethoden1.class, "hochZwei"},
         { 0,  0},
         { 1,  1},
         { 1, -1},
         { 4,  2},
         { 4, -2},
         { 9,  3},
         { 9, -3},
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_hochZwei
   // ---------------------------------------------------------------------
   static public void tst_zweiHoch() {
      Object[][] aa = {
         {UebMethoden1.class, "zweiHoch"},
         {    1,  0},
         {    2,  1},
         {    4,  2},
         {    8,  3},
         {   16,  4},
         { 1024, 10},
         {   1,  -3},
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_zweiHoch
   // ---------------------------------------------------------------------
   static public void tst_hoch() {
      Object[][] aa = {
         {UebMethoden1.class, "hoch"},
         {    0,  0,  1},
         {    0,  0, 99},
         {    1,  1,  0},
         {    1,  1,  1},
         {    1,  1, 99},
         {    1,  2,  0},
         {    2,  2,  1},
         {    4,  2,  2},
         { 1024,  2, 10},
         {    1,  3,  0},
         {    3,  3,  1},
         {    9,  3,  2},
         { 6561,  3,  8},
         {   -3, -3,  1},
         {    9, -3,  2},
         {  -27, -3,  3},
         {   81, -3,  4},
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_hoch
   // ---------------------------------------------------------------------
   static public void tst_istPrim() {
      Object[][] aa = {
         {UebMethoden1.class, "istPrim"},
         {false,    0},
         {false,    1},
         {true,     2},
         {true,    23},
         {false,  161},
         {false,  1000021},
         {false,  1000023},
         {true,   1000037},
         {true,   1000039},
         {true,   2000081},
         {true,   2000083},
         {true,   9000377},
         {true,   9000379},
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_istPrim
   // ---------------------------------------------------------------------
   static public void tst_primDoublette() {
      Object[][] aa = {
         {UebMethoden1.class, "primDoublette"},
         {      3,           1},
         {     11,           6},
         {1000037,     1000000},
         {2000081,     2000000},
         {9000377,     9000000},
         {      0,  2147483000},
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_primDoublette
   // ---------------------------------------------------------------------
   static public void tst_alleRechtwinkligen() {
      Object[][] aa = {
         {UebMethoden1.class, "alleRechtwinkligen"},
         { "Nr. 1: 5, 4, 3.\n"      +
           "Nr. 2: 10, 8, 6.\n"     +
           "Nr. 3: 13, 12, 5.\n"    +
           "Nr. 4: 15, 12, 9.\n"    +
           "Nr. 5: 17, 15, 8.\n"    +
           "Nr. 6: 20, 16, 12.\n"   +
           "Nr. 7: 25, 20, 15.\n"   +
           "Nr. 8: 25, 24, 7.\n"    +
           "Nr. 9: 26, 24, 10.\n"   +
           "Nr. 10: 29, 21, 20.\n"  +
           "Nr. 11: 30, 24, 18.\n"  +
           "Nr. 12: 34, 30, 16.\n"  +
           "Nr. 13: 35, 28, 21.\n"  +
           "Nr. 14: 37, 35, 12.\n"  +
           "Nr. 15: 39, 36, 15.\n"  +
           "Nr. 16: 40, 32, 24.\n"  +
           "Nr. 17: 41, 40, 9.\n"   +
           "Nr. 18: 45, 36, 27.\n"  +
           "Nr. 19: 50, 40, 30.\n"  +
           "Nr. 20: 50, 48, 14.\n"  +
           "Nr. 21: 51, 45, 24.\n"  +
           "Nr. 22: 52, 48, 20.\n"  +
           "Nr. 23: 53, 45, 28.\n"  +
           "Nr. 24: 55, 44, 33.\n"  +
           "Nr. 25: 58, 42, 40.\n"  +
           "Nr. 26: 60, 48, 36.\n"  +
           "Nr. 27: 61, 60, 11.\n"  +
           "Nr. 28: 65, 52, 39.\n"  +
           "Nr. 29: 65, 56, 33.\n"  +
           "Nr. 30: 65, 60, 25.\n"  +
           "Nr. 31: 65, 63, 16.\n"  +
           "Nr. 32: 68, 60, 32.\n"  +
           "Nr. 33: 70, 56, 42.\n"  +
           "Nr. 34: 73, 55, 48.\n"  +
           "Nr. 35: 74, 70, 24.\n"  +
           "Nr. 36: 75, 60, 45.\n"  +
           "Nr. 37: 75, 72, 21.\n"  +
           "Nr. 38: 78, 72, 30.\n"  +
           "Nr. 39: 80, 64, 48.\n"  +
           "Nr. 40: 82, 80, 18.\n"  +
           "Nr. 41: 85, 68, 51.\n"  +
           "Nr. 42: 85, 75, 40.\n"  +
           "Nr. 43: 85, 77, 36.\n"  +
           "Nr. 44: 85, 84, 13.\n"  +
           "Nr. 45: 87, 63, 60.\n"  +
           "Nr. 46: 89, 80, 39.\n"  +
           "Nr. 47: 90, 72, 54.\n"  +
           "Nr. 48: 91, 84, 35.\n"  +
           "Nr. 49: 95, 76, 57.\n"  +
           "Nr. 50: 97, 72, 65.\n"  +
           "Nr. 51: 100, 80, 60.\n" +
           "Nr. 52: 100, 96, 28.\n"
         },
      };
      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_alleRechtwinkligen
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("UebMethoden1: Jetzt geht es los!%n");

      tst_summe();
      tst_gibAus();
      tst_hochZwei();
      tst_zweiHoch();
      tst_hoch();
      tst_istPrim();
      tst_primDoublette();
      tst_alleRechtwinkligen();

      printf("**************************************%n");
      printf("%s%n", MethodTest.totalsString());
      printf("**************************************%n");
      printf("UebMethoden1: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class UebMethoden1
