// Datei UebReihungen2.java
/* ------------------------------------------------------------------------
Methoden zum Bearbeiten von zweistufigen Reihungen.
Hier koennen Sie Ihre Loesungen fuer die Uebung Reihungen 2 eintragen
und testen.
------------------------------------------------------------------------ */
import        de.tfh_berlin.fb6.MethodTest;
import static de.tfh_berlin.fb6.MethodTest.p;
import static de.tfh_berlin.fb6.MethodTest.pln;

public class UebReihungen2 {
   // ---------------------------------------------------------------------
   static public int summe(int[][] irr) {
      // Liefert die Summe aller int-Komponenten von irr.

      return 999; // SOLLTE ERSETZT WERDEN
   } // summeN
   // ---------------------------------------------------------------------
   static public boolean alleGerade(int[][] irr) {
      // Liefert true, falls alle int-Komponenten von irr gerade sind und
      // sonst false.

      return false; // SOLLTE ERSETZT WERDEN
   } // alleGeradeN
   // ---------------------------------------------------------------------
   static public int anzahlGerade(int[][] irr) {
      // Liefert die Anzahl der geraden int-Komponenten von irr.

      return 999; // SOLLTE ERSETZT WERDEN
   } // anzahlGeradeN
   // ---------------------------------------------------------------------
   static public boolean kommtVor(int dieserWert, int[][] inDieserReihung) {
      // Liefert true, wenn dieserWert inDieserReihung (als int-Komponente)
      // vorkommt, und sonst false.

      return false; // SOLLTE ERSETZT WERDEN
   } // kommtVorN
   // ---------------------------------------------------------------------
   static public int anzahlKomponenten(int[][] irr) {
      // Liefert die Anzahl der int-Komponenten von irr.

      return 999;  // SOLLTE ERSETZT WERDEN
   } // anzahlKomponentenN
   // ---------------------------------------------------------------------
   static public void printR(String[] sonja) {
      // Gibt die Reihung sonja mit der Methode p in lesbarer Form aus,
      // z.B. so:
      // [ABC, DE, EFGH]
      // [12345, ab, !??, ***]
      // []                        // Wenn sonja leer ist.

      p("ABC");  // SOLLTE ERSETZT WERDEN
   } // printR
   // ---------------------------------------------------------------------
   static public int anzBuchstaben(String[] sonja) {
      // Liefert die Anzahl der Buchstaben, die in den Komponenten von
      // sonja vorkommen.

      return 999; // SOLLTE ERSETZT WERDEN
   } // anzBuchstabenN
   // =====================================================================
   static final boolean FAILURES_ONLY = false;
   // ---------------------------------------------------------------------
   static public void tst_summe() {
      Object[][] aa = {
         {UebReihungen2.class, "summe"},
         { 210, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         { 100, new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {  10, new int[][]{{}, {}, {}, {10}}             },
         {   0, new int[][]{{}, {}, {}, {}}               },
         {   0, new int[][]{}                             },
      };

      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_summeN
   // ---------------------------------------------------------------------
   static public void tst_alleGerade() {
      Object[][] aa = {
         {UebReihungen2.class, "alleGerade"},
         {true , new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {false, new int[][]{{10, 21, 30}, {40, 50}, {60}} },
         {false, new int[][]{{10, 20, 30}, {40, 50}, {61}} },
         {true , new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {false, new int[][]{{}, {11, 21}, {}, {31, 41}}   },
         {false, new int[][]{{}, {10, 20}, {}, {31, 40}}   },
         {true , new int[][]{{}, {}, {}, {10}}             },
         {false, new int[][]{{}, {}, {}, {17}}             },
         {true , new int[][]{{}, {}, {}, {}}               },
         {true , new int[][]{}                             },
      };

      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_alleGeradeN
   // ---------------------------------------------------------------------
   static public void tst_anzahlGerade() {
      Object[][] aa = {
         {UebReihungen2.class, "anzahlGerade"},
         {6, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {5, new int[][]{{10, 21, 30}, {40, 50}, {60}} },
         {5, new int[][]{{10, 20, 30}, {40, 50}, {61}} },
         {4, new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {0, new int[][]{{}, {11, 21}, {}, {31, 41}}   },
         {3, new int[][]{{}, {10, 20}, {}, {31, 40}}   },
         {1, new int[][]{{}, {}, {}, {10}}             },
         {0, new int[][]{{}, {}, {}, {17}}             },
         {0, new int[][]{{}, {}, {}, {}}               },
         {0, new int[][]{}                             },
      };

      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_anzahlGeradeN
   // ---------------------------------------------------------------------
   static public void tst_kommtVor() {
      Object[][] aa = {
         {UebReihungen2.class, "kommtVor"},
         {true , 10, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {true , 20, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {true , 30, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {true , 40, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {true , 50, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {true , 60, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {false, 15, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {false, 45, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {false, 65, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {true , 10, new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {true , 40, new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {false, -1, new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {false, 99, new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {true , 10, new int[][]{{}, {}, {}, {10}}             },
         {false, 11, new int[][]{{}, {}, {}, {10}}             },
         {false, 10, new int[][]{{}, {}, {}, {}}               },
         {false, 10, new int[][]{}                             },
      };

      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_kommtVorN
   // ---------------------------------------------------------------------
   static public void tst_anzahlKomponenten() {
      Object[][] aa = {
         {UebReihungen2.class, "anzahlKomponenten"},
         {6, new int[][]{{10, 20, 30}, {40, 50}, {60}} },
         {6, new int[][]{{10, 21, 30}, {40, 50}, {60}} },
         {4, new int[][]{{}, {10, 20}, {}, {30, 40}}   },
         {4, new int[][]{{}, {11, 21}, {}, {31, 41}}   },
         {1, new int[][]{{}, {}, {}, {10}}             },
         {1, new int[][]{{}, {}, {}, {17}}             },
         {0, new int[][]{{}, {}, {}, {}}               },
         {0, new int[][]{}                             },
      };

      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_anzahlKomponentenN
   // ---------------------------------------------------------------------
   static public void tst_printR() {
      Object[][] aa = {
         {UebReihungen2.class, "printR"},
         {"[ABC, DE, FGHI]", new String[]{"ABC", "DE", "FGHI"} },
         {"[ABC, DE]"      , new String[]{"ABC", "DE"}         },
         {"[ABC]"          , new String[]{"ABC"}               },
         {"[]"             , new String[]{}                    },
      };

      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_printR
   // ---------------------------------------------------------------------
   static public void tst_anzBuchstaben() {
      Object[][] aa = {
         {UebReihungen2.class, "anzBuchstaben"},
         {9, new String[]{"ABC", "DE", "FGHI"} },
         {5, new String[]{"1BC", "D2", "F34I"} },
         {5, new String[]{"ABC", "DE"}         },
         {3, new String[]{"AB1", "D2"}         },
         {0, new String[]{"123", "45"}         },
         {3, new String[]{"ABC"}               },
         {2, new String[]{"A1C"}               },
         {0, new String[]{"123"}               },
         {0, new String[]{}                    },
      };

      MethodTest mt = new MethodTest(aa, FAILURES_ONLY);
   } // tst_anzBuchstabenN
   // =====================================================================
   static public void main(String[] _) {
      printf("UebReihungen2: Jetzt geht es los!%n");

      tst_summe();
      tst_alleGerade();
      tst_anzahlGerade();
      tst_kommtVor();
      tst_anzahlKomponenten();
      tst_printR();
      tst_anzBuchstaben();

      printf("**************************************%n");
      printf("%s%n", MethodTest.totalsString());
      printf("**************************************%n");
      printf("--------------------------------------%n");
      printf("UebReihungen2: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class UebReihungen2
/* ------------------------------------------------------------------------
Ausgabe des Programms:

UebReihungen2: Jetzt geht es los!
--------------------------------------
Class : UebReihungen2, Method: summe

UebReihungen2.summe([[10, 20, 30], [40, 50], [60]]): xp:210, is:999 ****
UebReihungen2.summe([[], [10, 20], [], [30, 40]]  ): xp:100, is:999 ****
UebReihungen2.summe([[], [], [], [10]]            ): xp: 10, is:999 ****
UebReihungen2.summe([[], [], [], []]              ): xp:  0, is:999 ****
UebReihungen2.summe([]                            ): xp:  0, is:999 ****

Number of calls:  5, failures:  5
--------------------------------------
Class : UebReihungen2, Method: alleGerade

UebReihungen2.alleGerade([[10, 20, 30], [40, 50], [60]]): xp:true , is:false ****
UebReihungen2.alleGerade([[10, 21, 30], [40, 50], [60]]): xp:false, is:false o.k.
UebReihungen2.alleGerade([[10, 20, 30], [40, 50], [61]]): xp:false, is:false o.k.
UebReihungen2.alleGerade([[], [10, 20], [], [30, 40]]  ): xp:true , is:false ****
UebReihungen2.alleGerade([[], [11, 21], [], [31, 41]]  ): xp:false, is:false o.k.
UebReihungen2.alleGerade([[], [10, 20], [], [31, 40]]  ): xp:false, is:false o.k.
UebReihungen2.alleGerade([[], [], [], [10]]            ): xp:true , is:false ****
UebReihungen2.alleGerade([[], [], [], [17]]            ): xp:false, is:false o.k.
UebReihungen2.alleGerade([[], [], [], []]              ): xp:true , is:false ****
UebReihungen2.alleGerade([]                            ): xp:true , is:false ****

Number of calls: 10, failures:  5
--------------------------------------
Class : UebReihungen2, Method: anzahlGerade

UebReihungen2.anzahlGerade([[10, 20, 30], [40, 50], [60]]): xp:6, is:999 ****
UebReihungen2.anzahlGerade([[10, 21, 30], [40, 50], [60]]): xp:5, is:999 ****
UebReihungen2.anzahlGerade([[10, 20, 30], [40, 50], [61]]): xp:5, is:999 ****
UebReihungen2.anzahlGerade([[], [10, 20], [], [30, 40]]  ): xp:4, is:999 ****
UebReihungen2.anzahlGerade([[], [11, 21], [], [31, 41]]  ): xp:0, is:999 ****
UebReihungen2.anzahlGerade([[], [10, 20], [], [31, 40]]  ): xp:3, is:999 ****
UebReihungen2.anzahlGerade([[], [], [], [10]]            ): xp:1, is:999 ****
UebReihungen2.anzahlGerade([[], [], [], [17]]            ): xp:0, is:999 ****
UebReihungen2.anzahlGerade([[], [], [], []]              ): xp:0, is:999 ****
UebReihungen2.anzahlGerade([]                            ): xp:0, is:999 ****

Number of calls: 10, failures: 10
--------------------------------------
Class : UebReihungen2, Method: kommtVor

UebReihungen2.kommtVor(10,[[10, 20, 30], [40, 50], [60]]): xp:true , is:false ****
UebReihungen2.kommtVor(20,[[10, 20, 30], [40, 50], [60]]): xp:true , is:false ****
UebReihungen2.kommtVor(30,[[10, 20, 30], [40, 50], [60]]): xp:true , is:false ****
UebReihungen2.kommtVor(40,[[10, 20, 30], [40, 50], [60]]): xp:true , is:false ****
UebReihungen2.kommtVor(50,[[10, 20, 30], [40, 50], [60]]): xp:true , is:false ****
UebReihungen2.kommtVor(60,[[10, 20, 30], [40, 50], [60]]): xp:true , is:false ****
UebReihungen2.kommtVor(15,[[10, 20, 30], [40, 50], [60]]): xp:false, is:false o.k.
UebReihungen2.kommtVor(45,[[10, 20, 30], [40, 50], [60]]): xp:false, is:false o.k.
UebReihungen2.kommtVor(65,[[10, 20, 30], [40, 50], [60]]): xp:false, is:false o.k.
UebReihungen2.kommtVor(10,[[], [10, 20], [], [30, 40]]  ): xp:true , is:false ****
UebReihungen2.kommtVor(40,[[], [10, 20], [], [30, 40]]  ): xp:true , is:false ****
UebReihungen2.kommtVor(-1,[[], [10, 20], [], [30, 40]]  ): xp:false, is:false o.k.
UebReihungen2.kommtVor(99,[[], [10, 20], [], [30, 40]]  ): xp:false, is:false o.k.
UebReihungen2.kommtVor(10,[[], [], [], [10]]            ): xp:true , is:false ****
UebReihungen2.kommtVor(11,[[], [], [], [10]]            ): xp:false, is:false o.k.
UebReihungen2.kommtVor(10,[[], [], [], []]              ): xp:false, is:false o.k.
UebReihungen2.kommtVor(10,[]                            ): xp:false, is:false o.k.

Number of calls: 17, failures:  9
--------------------------------------
Class : UebReihungen2, Method: anzahlKomponenten

UebReihungen2.anzahlKomponenten([[10, 20, 30], [40, 50], [60]]): xp:6, is:999 ****
UebReihungen2.anzahlKomponenten([[10, 21, 30], [40, 50], [60]]): xp:6, is:999 ****
UebReihungen2.anzahlKomponenten([[], [10, 20], [], [30, 40]]  ): xp:4, is:999 ****
UebReihungen2.anzahlKomponenten([[], [11, 21], [], [31, 41]]  ): xp:4, is:999 ****
UebReihungen2.anzahlKomponenten([[], [], [], [10]]            ): xp:1, is:999 ****
UebReihungen2.anzahlKomponenten([[], [], [], [17]]            ): xp:1, is:999 ****
UebReihungen2.anzahlKomponenten([[], [], [], []]              ): xp:0, is:999 ****
UebReihungen2.anzahlKomponenten([]                            ): xp:0, is:999 ****

Number of calls:  8, failures:  8
--------------------------------------
Class : UebReihungen2, Method: printR

UebReihungen2.printR(["ABC", "DE", "FGHI"]): xp:"[ABC, DE, FGHI]", is:"ABC" ****
UebReihungen2.printR(["ABC", "DE"]        ): xp:"[ABC, DE]"      , is:"ABC" ****
UebReihungen2.printR(["ABC"]              ): xp:"[ABC]"          , is:"ABC" ****
UebReihungen2.printR([]                   ): xp:"[]"             , is:"ABC" ****

Number of calls:  4, failures:  4
--------------------------------------
Class : UebReihungen2, Method: anzBuchstaben

UebReihungen2.anzBuchstaben(["ABC", "DE", "FGHI"]): xp:9, is:999 ****
UebReihungen2.anzBuchstaben(["1BC", "D2", "F34I"]): xp:5, is:999 ****
UebReihungen2.anzBuchstaben(["ABC", "DE"]        ): xp:5, is:999 ****
UebReihungen2.anzBuchstaben(["AB1", "D2"]        ): xp:3, is:999 ****
UebReihungen2.anzBuchstaben(["123", "45"]        ): xp:0, is:999 ****
UebReihungen2.anzBuchstaben(["ABC"]              ): xp:3, is:999 ****
UebReihungen2.anzBuchstaben(["A1C"]              ): xp:2, is:999 ****
UebReihungen2.anzBuchstaben(["123"]              ): xp:0, is:999 ****
UebReihungen2.anzBuchstaben([]                   ): xp:0, is:999 ****

Number of calls:  9, failures:  9
**************************************
*** Total calls: 63, failures: 50
**************************************
--------------------------------------
UebReihungen2: Das war's erstmal!
------------------------------------------------------------------------ */
